Index: /SMC/trunk/SMC/src/web/scripts/js/smc-graph.js
===================================================================
--- /SMC/trunk/SMC/src/web/scripts/js/smc-graph.js	(revision 6845)
+++ /SMC/trunk/SMC/src/web/scripts/js/smc-graph.js	(revision 6846)
@@ -621,76 +717,77 @@
             rect.remove();
             d3.select(window).on("mousemove", null).on("mouseup", null);
-          });
-        
-          d3.event.preventDefault();
-        });
+        });
+
+        d3.event.preventDefault();
+    });
 }  // end renderGraph
 
 
 /** loads detail info about individual nodes (in html) from separate file  
-later used in renderDetail() 
-invoked during the (jquery-)initalization */
-function loadDetailInfo () {
-     
-     if (mode=='static') {
-     $(detail_info_holder_selector).load(config.url.detail,function(data) {
-        $(detail_container_selector).find("h3").after(
-        '<div id="detail-summary-overall" class="cmds-ui-block init-show" ><div class="header">Overview</div><div class="content">'
-        + getDetailInfo("summary", "overall") + '</div></div>');
-        
-        handleUIBlock($(detail_container_selector).find(".cmds-ui-block"));
-        
-        // only render detail for initially selected nodes, after the detail info has been loaded 
-        if (nodes_sel) { renderDetail(nodes_sel) };
-     
-       });
-      } else {
-          var target_container = $(detail_container_selector).append(
-            '<div id="detail-summary-overall" class="cmds-ui-block init-show" ><div class="header">Overview</div></div>');
-            $(detail_container_selector).find('#detail-summary-overall').append('<div class="content"></div>');
-            target = $(detail_container_selector).find("#detail-summary-overall .content")
-            getDetailInfo("summary", "overall", target, function() {            
-                        handleUIBlock($(detail_container_selector).find(".cmds-ui-block"));
-                        });
-            
-      }
-  
-  // loading css to store in extra variable, for later use = injecting into exported SVG 
-  $.get("scripts/style/smc-graph.css", function(data) {
- //  console.log(data)
-    css = data
-  });
-  
-}
-
-function getDetailInfo(type, id, target,load_callback) {
+ later used in renderDetail() 
+ invoked during the (jquery-)initalization */
+function loadDetailInfo() {
+    if (mode == 'static') {
+        $(detail_info_holder_selector).load(config.url.detail, function (data) {
+            $(detail_container_selector).find("h3").after(
+                    '<div id="detail-summary-overall" class="cmds-ui-block init-show" ><div class="header">Overview</div><div class="content">' +
+                    getDetailInfo("summary", "overall") +
+                    '</div></div>'
+                    );
+
+            handleUIBlock($(detail_container_selector).find(".cmds-ui-block"));
+
+            // only render detail for initially selected nodes, after the detail info has been loaded 
+            if (nodes_sel) {
+                renderDetail(nodes_sel)
+            }
+            ;
+
+        });
+    } else {
+        var target_container = $(detail_container_selector).append(
+                '<div id="detail-summary-overall" class="cmds-ui-block init-show" ><div class="header">Overview</div></div>'
+                );
+        $(detail_container_selector).find('#detail-summary-overall').append('<div class="content"></div>');
+        target = $(detail_container_selector).find("#detail-summary-overall .content")
+        getDetailInfo("summary", "overall", target, function () {
+            handleUIBlock($(detail_container_selector).find(".cmds-ui-block"));
+        });
+    }
+
+    // loading css to store in extra variable, for later use = injecting into exported SVG 
+    $.get("scripts/style/smc-graph.css", function (data) {
+        //  console.log(data)
+        css = data
+    });
+}
+
+function getDetailInfo(type, id, target, load_callback) {
     //notify("getDetailInfo: #" + type + "-" + id );
-    
-    if (type=='philosopher') {
-    // access origin problem!
-        url = "http://localhost/smc-dev/get.php?link=" + wiki_url + id;
-         $(target).load(url + " .infobox");         
-    } else 
-        if (mode=='static' ) {
-            var d = $(detail_info_holder_selector).find("#" + type + "-" + id );
-            return d.html();       
-        } else {
-            var url = config.url.detail + "?type=" + type + "&key=" + id;
-            console.log("get-detail:" + url );
-                $(target).toggleClass("loading");
-                 $(target).load(url,load_callback);
-        }
+
+    if (type == 'philosopher') {
+        url = "get.php?link=" + wiki_url + id;
+        $(target).load(url + " .infobox");
+    } else if (mode == 'static') {
+        var d = $(detail_info_holder_selector).find("#" + type + "-" + id);
+        return d.html();
+    } else {
+        var url = config.url.detail + "?type=" + type + "&key=" + id;
+        console.log("get-detail:" + url);
+        $(target).toggleClass("loading");
+        $(target).load(url, load_callback);
+    }
     // notify(d);
-    
+
 }
 
 /** generates a base64-data encoded url out of the current svg
-does some preprocessing: injects the css and sets the @viewBox, @width and @height attributes to ensure, 
-that everything is visible in the exported svg.
-later perhaps even exporting to server, for rendering to PNG, PDF
-http://d3export.cancan.cshl.edu/
-called on mousedown of the download-link, so assumes the <a>-element as this
-*/
-function genDownload (event) {
+ does some preprocessing: injects the css and sets the @viewBox, @width and @height attributes to ensure, 
+ that everything is visible in the exported svg.
+ later perhaps even exporting to server, for rendering to PNG, PDF
+ http://d3export.cancan.cshl.edu/
+ called on mousedown of the download-link, so assumes the <a>-element as this
+ */
+function genDownload(event) {
 //console.log("genDownload:" + this);
 
@@ -700,36 +797,36 @@
     var margin = 30;
     var link_dist = parseInt(opt("link-distance"));
-    
+
     var x, y, w, h;
-    x = Math.floor(bounds["x-min"]) - margin 
+    x = Math.floor(bounds["x-min"]) - margin
     y = Math.floor(bounds["y-min"]) - margin
     // add extra space to the right, because of the possible labels 
-    w = (bounds["width"] > svg_w) ? bounds["width"] + 2 * margin + link_dist : svg_w + link_dist;  
+    w = (bounds["width"] > svg_w) ? bounds["width"] + 2 * margin + link_dist : svg_w + link_dist;
     h = (bounds["height"] > svg_h) ? bounds["height"] + 2 * margin : svg_h;
-       
+
     var viewBox = x + " " + y + " " + w + " " + h;
 
-  svg.attr("title", "SMC Browser - export")
-        .attr("version", 1.1)
-        .attr("viewBox", viewBox)
-        .attr("width", w)
-        .attr("height", h)
-        .attr("xmlns", "http://www.w3.org/2000/svg");
-      var style = svg.append("style" );
-        style.attr("type", 'text/css');
-        style.text(css);
-
-var html = svg.node().parentNode.innerHTML;
-
-/*    $(html).append("<style type='text/css'><![CDATA[" + css + "]]> </style>" );*/
-     
-        
+    svg.attr("title", "SMC Browser - export")
+            .attr("version", 1.1)
+            .attr("viewBox", viewBox)
+            .attr("width", w)
+            .attr("height", h)
+            .attr("xmlns", "http://www.w3.org/2000/svg");
+    var style = svg.append("style");
+    style.attr("type", 'text/css');
+    style.text(css);
+
+    var html = svg.node().parentNode.innerHTML;
+
+    /*    $(html).append("<style type='text/css'><![CDATA[" + css + "]]> </style>" );*/
+
+
     //console.log(html);
 
     $(this).attr("title", "smc-browser-export.svg")
-      .attr("target", "_blank")
-      .attr("href-lang", "image/svg+xml")
-      .attr("href", "data:image/svg+xml;base64,\n" + btoa(html));
-      
+            .attr("target", "_blank")
+            .attr("href-lang", "image/svg+xml")
+            .attr("href", "data:image/svg+xml;base64,\n" + btoa(html));
+
 }
 
@@ -737,8 +834,8 @@
 /**  select the nodes within the specified rectangle. */
 function selectNodes(nodes, x0, y0, x3, y3) {
-    
-  var points = [];
-  nodes.forEach(function(n) {    
-    if (n && (n.x >= x0) && (n.x < x3) && (n.y >= y0) && (n.y < y3)) {
+
+    var points = [];
+    nodes.forEach(function (n) {
+        if (n && (n.x >= x0) && (n.x < x3) && (n.y >= y0) && (n.y < y3)) {
             points.push(n);
             n.selected = 1;
@@ -746,7 +843,7 @@
             n.selected = 0;
         }
-/*    return x1 >= x3 || y1 >= y3 || x2 < x0 || y2 < y0;*/
-  });
-  return points;
+        /*    return x1 >= x3 || y1 >= y3 || x2 < x0 || y2 < y0;*/
+    });
+    return points;
 }
 
@@ -754,194 +851,214 @@
 
     // get selected nodes (if any) from param
-      var selected_match = 0;
-        for (var i = 0; i < nodes_keys.length; i++)
-        {  if (data_all.nodes_index[nodes_keys[i]]) {
-                 data_all.nodes_index[nodes_keys[i]].selected = 1;
-                 selected_match ++;
-           }
-        }    
-      // if something was selected, update and render Graph and Detail
-      if (selected_match) { updateSelected();}
-}
-
-function updateSelected () {
+    var selected_match = 0;
+    for (var i = 0; i < nodes_keys.length; i++)
+    {
+        if (data_all.nodes_index[nodes_keys[i]]) {
+            data_all.nodes_index[nodes_keys[i]].selected = 1;
+            selected_match++;
+        }
+    }
+    // if something was selected, update and render Graph and Detail
+    if (selected_match) {
+        updateSelected();
+    }
+}
+
+function updateSelected() {
 
     // don't change the selected nodes on freeze-layout
-if (opt("layout")!='freeze') {
-    nodes_sel = data_all.nodes.filter(function (d) { return d.selected });
-console.log("updateSelected:" + nodes_sel);    
-    // update param
-      var selected = [];
-      nodes_sel.forEach(function(d) { selected.push(d.key) });
-    $("#navigate").data("qi").setParamValue("selected",selected.join());
-    renderDetail(nodes_sel);
-    
-  }
-    
+    if (opt("layout") != 'freeze') {
+        nodes_sel = data_all.nodes.filter(function (d) {
+            return d.selected
+        });
+        console.log("updateSelected:");
+        console.log(nodes_sel);
+        // update param
+        var selected = [];
+        nodes_sel.forEach(function (d) {
+            selected.push(d.key)
+        });
+        $("#navigate").data("qi").setParamValue("selected", selected.join());
+        renderDetail(nodes_sel);
+
+    }
+
     renderGraph();
-    
- // just need to highlight the selected nodes
-    d3.select(index_container_selector).selectAll("li").classed("highlight", function (d) { return d.selected });
- //   renderIndex(); - this would be unnecessary and too expensive   
+
+    // just need to highlight the selected nodes
+    d3.select(index_container_selector).selectAll("li").classed("highlight", function (d) {
+        return d.selected
+    });
+    //   renderIndex(); - this would be unnecessary and too expensive   
 }
 
 
 /** Returns an event handler for highlighting the path of selected (mouseover) node.
-*/
+ */
 function highlight() {
-   max_depth = parseInt(opt("depth-before")) + parseInt(opt("depth-after"));
-   console.log ("max_depth:" + max_depth);
-  return function(d, i) {
-    // console.log ("fade:" + d.key);
-    //var connected_subgraph_in = neighboursWithLinks(data_show, d,'in', -1);
-    //var connected_subgraph_out = neighboursWithLinks(data_show, d,'out', -1);
-    
-    var connected_subgraph_in = neighboursWithLinks(data_show, d,'in', max_depth);
-    var connected_subgraph_out = neighboursWithLinks(data_show, d,'out', max_depth);
-    var connected_subgraph = {"nodes": [], "links": []};
+    max_depth = parseInt(opt("depth-before")) + parseInt(opt("depth-after"));
+    console.log("max_depth:" + max_depth);
+    return function (d, i) {
+        // console.log ("fade:" + d.key);
+        //var connected_subgraph_in = neighboursWithLinks(data_show, d,'in', -1);
+        //var connected_subgraph_out = neighboursWithLinks(data_show, d,'out', -1);
+
+        var connected_subgraph_in = neighboursWithLinks(data_show, d, 'in', max_depth);
+        var connected_subgraph_out = neighboursWithLinks(data_show, d, 'out', max_depth);
+        var connected_subgraph = {"nodes": [], "links": []};
         connected_subgraph.nodes = connected_subgraph.nodes.concat(connected_subgraph_in.nodes).concat(connected_subgraph_out.nodes);
         connected_subgraph.links = connected_subgraph.links.concat(connected_subgraph_in.links).concat(connected_subgraph_out.links);
-       add_lookups(connected_subgraph);                 
-    svg.selectAll("path.link")
-/*        .filter( d.source.index != i && d.target.index != i; })*/
-/*      .transition()*/
-        .classed("highlight", function(p) { return connected_subgraph.links_index[p.source.key + ',' + p.target.key] })
-        .classed("fade", function(p) { return !(connected_subgraph.links_index[p.source.key + ',' + p.target.key]) });
-    
-    connected = svg.selectAll("g.node").filter(function(d) { 
-                    return  connected_subgraph.nodes_in[d.key]  || connected_subgraph.nodes_out[d.key]  
-                    })
+        add_lookups(connected_subgraph);
+        svg.selectAll("path.link")
+                /*        .filter( d.source.index != i && d.target.index != i; })*/
+                /*      .transition()*/
+                .classed("highlight", function (p) {
+                    return connected_subgraph.links_index[p.source.key + ',' + p.target.key]
+                })
+                .classed("fade", function (p) {
+                    return !(connected_subgraph.links_index[p.source.key + ',' + p.target.key])
+                });
+
+        connected = svg.selectAll("g.node").filter(function (d) {
+            return  connected_subgraph.nodes_in[d.key] || connected_subgraph.nodes_out[d.key]
+        })
                 .classed("highlight", 1)
                 .classed("fade", 0);
-                
-    connected.selectAll("text").classed("hide",0);                 
-     not_connected = svg.selectAll("g.node").filter(function(d) { 
-                    return  !(connected_subgraph.nodes_in[d.key]  || connected_subgraph.nodes_out[d.key])  
-                    })
-                    .classed("highlight",0)
-                    .classed("fade",1);
-    not_connected.selectAll("text").classed("hide",1);                    
-                    
-    /*svg.selectAll("circle")
-/\*        .filter( d.source.index != i && d.target.index != i; })*\/
-/\*      .transition()*\/
-        .classed("highlight", function(d) { return connected_subgraph.nodes_in[d.key]  || connected_subgraph.nodes_out[d.key]  })
-        .classed("fade", function(d) { return !(connected_subgraph.nodes_in[d.key] || connected_subgraph.nodes_out[d.key])   });*/
-/*
-   if (opt("labels") =='show') {
-           gnodes.append("svg:text")
-                 .attr("x", 8)
-                 .attr("y", ".31em")
-                 .attr("class", "shadow")
-                 .text(function(d) { return d.name; });
-           gnodes.append("svg:text")
-                 .attr("x", 8)
-                 .attr("y", ".31em")
-                 .text(function(d) { return d.name; });
+
+        connected.selectAll("text").classed("hide", 0);
+        not_connected = svg.selectAll("g.node").filter(function (d) {
+            return  !(connected_subgraph.nodes_in[d.key] || connected_subgraph.nodes_out[d.key])
+        })
+                .classed("highlight", 0)
+                .classed("fade", 1);
+        not_connected.selectAll("text").classed("hide", 1);
+
+        /*svg.selectAll("circle")
+         /\*        .filter( d.source.index != i && d.target.index != i; })*\/
+         /\*      .transition()*\/
+         .classed("highlight", function(d) { return connected_subgraph.nodes_in[d.key]  || connected_subgraph.nodes_out[d.key]  })
+         .classed("fade", function(d) { return !(connected_subgraph.nodes_in[d.key] || connected_subgraph.nodes_out[d.key])   });*/
+        /*
+         if (opt("labels") =='show') {
+         gnodes.append("svg:text")
+         .attr("x", 8)
+         .attr("y", ".31em")
+         .attr("class", "shadow")
+         .text(function(d) { return d.name; });
+         gnodes.append("svg:text")
+         .attr("x", 8)
+         .attr("y", ".31em")
+         .text(function(d) { return d.name; });
+         }
+         */
+    };
+}
+
+function unhighlight() {
+    return function (d, i) {
+
+        svg.selectAll("path.link")
+                .classed("highlight", 0)
+                .classed("fade", 0);
+
+        var gnodes = svg.selectAll("g.node")
+                .classed("highlight", 0)
+                .classed("fade", 0);
+
+        gnodes.selectAll("text").classed("hide", function (d) {
+            return !d.selected && opt("labels") == 'hide'
+        });
+
+    };
+}
+
+
+/**  generates the subset of data to display (based on selected nodes + options) 
+ fills global variable: data_show ! 
+ */
+function dataToShow(nodes) {
+    data_show = {};
+    data_show.nodes = nodes;
+    var data_show_collect = {nodes: [], links: []};
+
+    nodes.forEach(function (n) {
+        var data_add_in = neighboursWithLinks(data_all, n, 'in', opt("depth-before"));
+        var data_add_out = neighboursWithLinks(data_all, n, 'out', opt("depth-after"));
+        data_show_collect.nodes = data_show_collect.nodes.concat(data_add_in.nodes).concat(data_add_out.nodes);
+        data_show_collect.links = data_show_collect.links.concat(data_add_in.links).concat(data_add_out.links);
+    });
+
+    /*         deduplicate nodes and edges */
+    data_show.nodes = unique_nodes(nodes.concat(data_show_collect.nodes));
+    data_show.links = unique_links(data_show_collect.links);
+
+    // extend the object, with some lookup hashes on neighbourhood
+    add_lookups(data_show);
+
+    return data_show;
+}
+
+/** generate lookup hashes for neighbours;
+ for faster/simpler neighborhood lookup
+ from: http://stackoverflow.com/questions/8739072/highlight-selected-node-its-links-and-its-children-in-a-d3-js-force-directed-g
+ */
+function add_lookups(data) {
+
+    var links = data.links;
+    var neighbours = {"links_index": {}, "nodes_index": {},
+        "nodes_in": {}, "nodes_out": {},
+        "links_in": {}, "links_out": {},
+        "roots": []};
+
+    data.nodes.forEach(function (d) {
+        neighbours.nodes_index[d.key] = d;
+    });
+
+    var targets = [];
+
+    links.forEach(function (d) {
+        src_key = d.source.key;
+        trg_key = d.target.key;
+
+        // generate lookup hashes for neighbours;
+        neighbours.links_index[src_key + "," + trg_key] = d;
+        if (d.source) {
+            if (!neighbours.nodes_in[trg_key]) {
+                neighbours.nodes_in[trg_key] = [d.source];
+                neighbours.links_in[trg_key] = [d];
+            } else {
+                neighbours.nodes_in[trg_key].push(d.source);
+                neighbours.links_in[trg_key].push(d);
+            }
         }
-    */
-  };
-}
-
-function unhighlight() {
-  return function(d, i) {
-                     
-    svg.selectAll("path.link")
-        .classed("highlight", 0 )
-        .classed("fade", 0 );
-    
-     var gnodes = svg.selectAll("g.node")
-        .classed("highlight", 0)
-        .classed("fade", 0);
-        
-        gnodes.selectAll("text").classed("hide",function(d) { return !d.selected && opt("labels")=='hide'});
-        
-  };
-}
-
-
-/**  generates the subset of data to display (based on selected nodes + options) 
-fills global variable: data_show ! 
-*/
-function dataToShow (nodes) {
-     data_show = {};
-     data_show.nodes = nodes;
-        var data_show_collect = {nodes:[],links:[]};
-        
-        nodes.forEach(function(n) {
-                        var data_add_in = neighboursWithLinks(data_all, n,'in', opt("depth-before"));
-                        var data_add_out = neighboursWithLinks(data_all, n,'out', opt("depth-after"));
-                        data_show_collect.nodes = data_show_collect.nodes.concat(data_add_in.nodes).concat(data_add_out.nodes);
-                        data_show_collect.links = data_show_collect.links.concat(data_add_in.links).concat(data_add_out.links);
-                    });
-            
-/*         deduplicate nodes and edges */
-     data_show.nodes = unique_nodes(nodes.concat(data_show_collect.nodes));
-     data_show.links = unique_links(data_show_collect.links);
-     
-     // extend the object, with some lookup hashes on neighbourhood
-     add_lookups(data_show);
-  
-     return data_show;
-    }
-
-/** generate lookup hashes for neighbours;
-    for faster/simpler neighborhood lookup
-from: http://stackoverflow.com/questions/8739072/highlight-selected-node-its-links-and-its-children-in-a-d3-js-force-directed-g
-*/
-function add_lookups(data) {
-
-    var links = data.links;
-    var neighbours = {"links_index": {}, "nodes_index": {}, 
-                      "nodes_in": {}, "nodes_out": {},
-                      "links_in": {}, "links_out": {}, 
-                      "roots": []};
-        
-        data.nodes.forEach(function(d){            
-            neighbours.nodes_index[d.key] = d;
-        });
-        
-        var targets=[];
-        
-        links.forEach(function(d) { 
-                            src_key = d.source.key;
-                            trg_key = d.target.key;
-                            
-                         // generate lookup hashes for neighbours;
-                            neighbours.links_index[src_key + "," + trg_key] = d;
-                            if (d.source) { 
-                                    if (! neighbours.nodes_in[trg_key]) { 
-                                        neighbours.nodes_in[trg_key] = [d.source];
-                                        neighbours.links_in[trg_key] = [d];
-                                     }  else {
-                                        neighbours.nodes_in[trg_key].push(d.source);
-                                        neighbours.links_in[trg_key].push(d);
-                                     }
-                             }
-                            if (d.target) {
-                                if (targets.indexOf(d.target.key) == -1 ) { targets.push(d.target.key); }
-                                
-                                    if (! neighbours.nodes_out[src_key]) { 
-                                        neighbours.nodes_out[src_key] = [d.target];
-                                        neighbours.links_out[src_key] = [d];
-                                    } else { 
-                                        neighbours.nodes_out[src_key].push(d.target);
-                                        neighbours.links_out[src_key].push(d) ;
-                                    }
-                             }
-                       });
-            
-        data.nodes.forEach(function(d){
-            if (targets.indexOf(d.key) == -1)
-            { neighbours.roots.push(d.key); }
-        });
-
-    
+        if (d.target) {
+            if (targets.indexOf(d.target.key) == -1) {
+                targets.push(d.target.key);
+            }
+
+            if (!neighbours.nodes_out[src_key]) {
+                neighbours.nodes_out[src_key] = [d.target];
+                neighbours.links_out[src_key] = [d];
+            } else {
+                neighbours.nodes_out[src_key].push(d.target);
+                neighbours.links_out[src_key].push(d);
+            }
+        }
+    });
+
+    data.nodes.forEach(function (d) {
+        if (targets.indexOf(d.key) == -1)
+        {
+            neighbours.roots.push(d.key);
+        }
+    });
+
+
     //if it is target, it is no root
-                            
-                            
-                       
+
+
+
     data = $.extend(data, neighbours);
-    return data; 
+    return data;
 }
 
@@ -949,12 +1066,12 @@
 
 /*                        item_detail.text(function (d) { return "links_in: " +  dataShowCount(d.key, "links_in") +  "; links_out: " +  dataShowCount(d.key, "links_out") ;
-                                                       })*/
-function dataShowCount(n_key, info_type) { 
+ })*/
+function dataShowCount(n_key, info_type) {
 
     if (data_show[info_type][n_key]) {
         return data_show[info_type][n_key].length;
-       } else {
+    } else {
         return 0
-       }
+    }
 }
 
@@ -964,9 +1081,12 @@
  @returns array of [x_min, y_min, x_max, y_max, (x_max - x_min), (y_max - y_min)]
  */
-function graphBounds () {
-
-var  x_arr = [], y_arr =[];
-
-data_show.nodes.forEach(function(d,i){x_arr.push(d.x); y_arr.push(d.y)})
+function graphBounds() {
+
+    var x_arr = [], y_arr = [];
+
+    data_show.nodes.forEach(function (d, i) {
+        x_arr.push(d.x);
+        y_arr.push(d.y)
+    })
 
     x_min = d3.min(x_arr);
@@ -974,69 +1094,87 @@
     y_min = d3.min(y_arr);
     y_max = d3.max(y_arr);
-                 
-   return {"x-min": x_min, "y-min": y_min, "x-max": x_max, "x-max": y_max, "width": (x_max - x_min), "height":(y_max - y_min)}
-}                 
-                 
+
+    return {"x-min": x_min, "y-min": y_min, "x-max": x_max, "x-max": y_max, "width": (x_max - x_min), "height": (y_max - y_min)}
+}
+
 /** returns appropriate link
-*/
+ */
 function neighbouring(a, b) {
 //console.log("neighbouring: " +a.key + "," + b.key ); 
-  return data_all.links_index[a.key + "," + b.key];
+    return data_all.links_index[a.key + "," + b.key];
 }
 
 
 /** access function to retrieve the neighbours from the hashes
-@param data base data to search for links (default: data_all)
-@param dir in|out|any  - but "any" branches in unexpected ways (because it goes in and out on every level = it takes all the children of the parent) 
-@param depth 0-n - go depth-levels; negative depth := no depth restriction = go to the end of the paths;
-@returns a sub-graph
-*/
-function neighboursWithLinks (data, n, dir, depth) {
+ @param data base data to search for links (default: data_all)
+ @param dir in|out|any  - but "any" branches in unexpected ways (because it goes in and out on every level = it takes all the children of the parent) 
+ @param depth 0-n - go depth-levels; negative depth := no depth restriction = go to the end of the paths;
+ @returns a sub-graph
+ */
+function neighboursWithLinks(data, n, dir, depth) {
 // setting defaults
-       depth = typeof depth !== 'undefined' ? depth : 1;
-       data = typeof data !== 'undefined' ? data : data_all;
+    depth = typeof depth !== 'undefined' ? depth : 1;
+    data = typeof data !== 'undefined' ? data : data_all;
     weight_threshold = parseInt(opt("weight")) / 100;
 //console.log("weight_threshold:" + weight_threshold + "; depth:" + depth + "; key: " + n.key); 
-    if (depth==0) { return {nodes:[], links:[]};}
-
-        /* don't filter at all */
-        if (weight_threshold == 1 | opt("weight")=="") {
-           var n_in = data.nodes_in[n.key] ? data.nodes_in[n.key] : [] ;
-           var n_out = data.nodes_out[n.key] ? data.nodes_out[n.key] : [] ;
-           var l_in = data.links_in[n.key] ? data.links_in[n.key] : [] ;
-           var l_out = data.links_out[n.key] ? data.links_out[n.key]  : [] ;
-        } else {
-            var l_in = data.links_in[n.key] ? data.links_in[n.key].filter(function(d, i) { return d.weight>=weight_threshold }) : [] ;
-            var l_out = data.links_out[n.key] ? data.links_out[n.key].filter(function(d, i) { return d.weight>=weight_threshold })  : [] ;
-            var n_in = data.nodes_in[n.key] ? data.nodes_in[n.key].filter(function(d, i) { return neighbouring(d,n).weight>=weight_threshold })  : [] ;
-           var n_out = data.nodes_out[n.key] ? data.nodes_out[n.key].filter(function(d, i) { return neighbouring(n,d).weight>=weight_threshold })  : [] ;
-        }
-        
-        var result_n = {nodes:[], links:[]};
-        if (dir == 'in' ) { result_n.nodes = n_in; result_n.links = l_in; }
-                   else if (dir == 'out' ) { result_n.nodes = n_out; result_n.links = l_out; }
-                   else { result_n.nodes = n_out.concat(n_in); result_n.links = l_out.concat(l_in);  }
-        var n_nextlevel = {nodes:[], links:[]};
-        if (depth > 0 || depth < 0) { 
-         result_n.nodes.forEach (function(n) 
-                     { var n_neighbours = neighboursWithLinks(data, n, dir, depth - 1);
-                     n_nextlevel.nodes = n_nextlevel.nodes.concat(n_neighbours.nodes); 
-                     n_nextlevel.links = n_nextlevel.links.concat(n_neighbours.links);
-                     })
-         }
-         result_n.nodes = result_n.nodes.concat(n_nextlevel.nodes);
-         result_n.links = result_n.links.concat(n_nextlevel.links);
-        
-        return result_n;
-        
+    if (depth == 0) {
+        return {nodes: [], links: []};
+    }
+
+    /* don't filter at all */
+    if (weight_threshold == 1 | opt("weight") == "") {
+        var n_in = data.nodes_in[n.key] ? data.nodes_in[n.key] : [];
+        var n_out = data.nodes_out[n.key] ? data.nodes_out[n.key] : [];
+        var l_in = data.links_in[n.key] ? data.links_in[n.key] : [];
+        var l_out = data.links_out[n.key] ? data.links_out[n.key] : [];
+    } else {
+        var l_in = data.links_in[n.key] ? data.links_in[n.key].filter(function (d, i) {
+            return d.weight >= weight_threshold
+        }) : [];
+        var l_out = data.links_out[n.key] ? data.links_out[n.key].filter(function (d, i) {
+            return d.weight >= weight_threshold
+        }) : [];
+        var n_in = data.nodes_in[n.key] ? data.nodes_in[n.key].filter(function (d, i) {
+            return neighbouring(d, n).weight >= weight_threshold
+        }) : [];
+        var n_out = data.nodes_out[n.key] ? data.nodes_out[n.key].filter(function (d, i) {
+            return neighbouring(n, d).weight >= weight_threshold
+        }) : [];
+    }
+
+    var result_n = {nodes: [], links: []};
+    if (dir == 'in') {
+        result_n.nodes = n_in;
+        result_n.links = l_in;
+    } else if (dir == 'out') {
+        result_n.nodes = n_out;
+        result_n.links = l_out;
+    } else {
+        result_n.nodes = n_out.concat(n_in);
+        result_n.links = l_out.concat(l_in);
+    }
+    var n_nextlevel = {nodes: [], links: []};
+    if (depth > 0 || depth < 0) {
+        result_n.nodes.forEach(function (n)
+        {
+            var n_neighbours = neighboursWithLinks(data, n, dir, depth - 1);
+            n_nextlevel.nodes = n_nextlevel.nodes.concat(n_neighbours.nodes);
+            n_nextlevel.links = n_nextlevel.links.concat(n_neighbours.links);
+        })
+    }
+    result_n.nodes = result_n.nodes.concat(n_nextlevel.nodes);
+    result_n.links = result_n.links.concat(n_nextlevel.links);
+
+    return result_n;
+
 }
 
 /** deduplicates based on index-property */
-function unique_nodes(nodes) 
+function unique_nodes(nodes)
 {
     var hash = {}, result = [];
-    for ( var i = 0, l = nodes.length; i < l; ++i ) {
-           n_key = nodes[i].key;
-        if ( !hash[n_key] ) { //it works with objects! in FF, at least
+    for (var i = 0, l = nodes.length; i < l; ++i) {
+        n_key = nodes[i].key;
+        if (!hash[n_key]) { //it works with objects! in FF, at least
             hash[ n_key ] = true;
             result.push(nodes[i]);
